

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include "../simple-jpeg/import_export_jpeg.h"


void export_JPEG_file(const char* filename, const unsigned char* image_chars,
		       int image_height, int image_width,
		       int num_components, int quality);
void import_JPEG_file(const char* filename, unsigned char** image_chars,
		       int* image_height, int* image_width,
		       int* num_components);

float find_average(unsigned char *image_chars, int h, int w);
void flip_X(unsigned char *image_chars, unsigned char **im_new, int h, int w);
void flip_Y(unsigned char *image_chars, unsigned char **im_new, int h, int w);

int main(int argc, char *argv[])
{
  int h, w, comp;
  unsigned char *image_chars, *im_new1, *im_new2;
  if(argc < 1) {
    fprintf(stderr, "Give filename as argument.\n");
    return -1;
  }
  import_JPEG_file(argv[1], &image_chars, &h, &w, &comp);

  printf("Averge of all values: %f\n", find_average(image_chars, h, w));
  
  flip_X(image_chars, &im_new1, h, w);
  export_JPEG_file("horizontal.jpeg", im_new1, h, w, comp, 75);

  flip_Y(image_chars, &im_new2, h, w);
  export_JPEG_file("vertical.jpeg", im_new2, h, w, comp, 75);

  free(image_chars);
  free(im_new1);
  free(im_new2);

  return 0;
}

float find_average(unsigned char *image_chars, int h, int w)
{
  int i, j;
  double sum = 0;
  for(i = 0; i < h; i++) {
    for(j = 0; j < w; j++) {
      sum+=(int)(image_chars[i*w+j]);
    }
  } 
  return sum/(h*w);
}

void flip_X(unsigned char *image_chars, unsigned char **im_new, int h, int w)
{
  int i, j;
  unsigned char *tmp;

  tmp = malloc(h*w*sizeof(unsigned char));

  for(i = 0; i < h; i++) {
    for(j = 0; j < w; j++) {
      tmp[(h-1-i)*w+j] = image_chars[i*w+j];
    }
  }

  *im_new = tmp;
  printf("Picture flipped around horizontal axis.\n");
}

void flip_Y(unsigned char *image_chars, unsigned char **im_new, int h, int w)
{
  int i, j;
  unsigned char *tmp;

  tmp = malloc(h*w*sizeof(unsigned char));

  for(i = 0; i < h; i++) {
    for(j = 0; j < w; j++) {
      tmp[i*w+(w-1-j)] = image_chars[i*w+j];
    }
  }

  *im_new = tmp;
  printf("Picture flipped around vertical axis.\n");
}
